#include <iostream> // Stream-basierte Ein-/Ausgabe kommt noch
#include <string> // String"klasse" kommt noch

using namespace std; // wegen neuer Standard-Header (die ohne .h) ntig
                     // Dev-C++ (also mingw) kommt auch ohne aus.

#define AUSGABE(x) cout << (x) << endl; // Dieses bitte erst mal ignorieren.

class Auto
{
    private:
    int kmStand;

    public:

    Auto() :
    kmStand (0)
    { } // Konstruktor initialisiert nur.

    void gebeGas (void) { /* was tun */ }


};

class Leihgegenstand
{
    private:
    double stundentarif;

    public:
    Leihgegenstand (double st) :
    stundentarif (st)
    { } // Konstruktor initialisiert nur.

    void kassiereAb (void) { /* was tun */ }
};

//Mehrfache Vererbung. Die ist in Java wegen mglicher Probleme nicht vorgesehen:

class Leihwagen :
public Auto,
public Leihgegenstand  // erbt von beiden
{
    private:
    string kennzeichen;

    public:

    Leihwagen(string kennz, double st) :
    Leihgegenstand (st),  // So kommt der Konstruktor der Mutterklasse
                          // an seine Argumente. Wenn der Konstruktor von
                          // Leihwagen startet (bernchste Zeile), muss das
                          // Mutterobjekt fertig sein!
    kennzeichen(kennz)
    { } // Konstruktor initialisiert nur.
};

int main ( int argc, char* (argv[]) )
{
    Leihwagen trabbi("HB-XY-1234", 0.10);
    trabbi.gebeGas(); // Trabbi ist Auto ...
    trabbi.kassiereAb(); // ... und Leihgegenstand
    return 0;
}

// Tipp: Nur von einer Klasse "richtig" erben, ansonsten
// die Iterfaces ("implements") von Java nachahmen:

class Verleihbar
{
    protected:
    double stundentarif;

    public:
    virtual void kassiereAb (void) = 0; // "pure virtual method",
                                        // "Rein virtuelle Methode". Die _muss_
                                        // in einer Klasse, die hiervon erbt,
                                        // ausprogrammiert werden, sonst darf
                                        // man davon keine Objekte erzeugen,
                                        // daher Bezeichnung "abstrakte Klasse"
                                        // fr eine Klasse mit solchen Methoden.
                                        // Verhlt sich also ungefhr wie
                                        // Java-Interface.
};
